/*
 * FrameCounter.java
 *
 * Created on 1. Mrz 2007, 18:20
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package Engine;

/**
 *
 * @author Sunshine
 */
public class FrameCounter {
    
    private int frames;
    private long fps;
    
    private long start;
    private long last;
    private long duration;
    
    /** Creates a new instance of FrameCounter */
    public FrameCounter() {
        reset();
    }
    
    private void reset()
    {
        frames = 0;
        start = 0;
    }
    
    public void start()
    {
        start = System.currentTimeMillis();
    }
    
    public void count()
    {
        frames++;
        last = System.currentTimeMillis();
        duration += (last - start);
        
        
        if (duration > 1000)
        {
            fps = (frames * 1000) / duration;
            frames = 0;
            duration = 1;
            start = System.currentTimeMillis();
        }
        else
            start = last;
        
    }
    
    public long getFPS()
    {
       return fps;
        
    }
    
}
