import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;
import java.awt.event.MouseMotionAdapter;
import java.io.BufferedReader;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.util.Vector;
//import java.io.File;
import javax.swing.*;
/*
 * LoadQuestFrame.java
 *
 * Created on 27. September 2007, 18:50
 */

/**
 *
 * @author  Sunshine
 */
public class LoadQuestFrame extends javax.swing.JFrame {
    
    private final SkyscraperApplet applet;
    public int numOfQuests;
    
    int x=-1;               // helper variables for handling mouse actions
    int y=-1;

    //private JPanel jPanel1;
    
    /** Creates new form LoadQuestFrame */
    public LoadQuestFrame(SkyscraperApplet applet ) {
        super();
        initComponents();
        this.applet = applet;
        this.setBounds(100, 100, 190, 240);
        this.setTitle("Load Quest");
        
        fillList();
        
        // react on load button
        this.LoadButton.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) 
            {
                LoadButtonAction(e);
            } 
        });
        
        this.CancelButton.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) 
            {
                setVisible(false);
            } 
        });
        
        TitleBarPanel.addMouseListener(new MouseAdapter(){
            public void mouseReleased(MouseEvent e){
                x = e.getX();
                y = e.getY();
            }
                public void mousePressed(MouseEvent e){
                x = e.getX();
                y = e.getY();
            }      
        });
        
        TitleBarPanel.addMouseMotionListener(new MouseMotionAdapter(){
            public void mouseDragged(MouseEvent e){
                int xx = getLocation().x;
                int yy = getLocation().y;
                setLocation(xx+(e.getX()-x),yy+(e.getY()-y));
             }
        });
    }
    
    public void LoadButtonAction(ActionEvent e)
    {
        if (QuestList.getSelectedIndex() != -1)
        {
            int tmp = QuestList.getSelectedIndex() + 1;
            applet.LoadQuest(tmp);
            this.setVisible(false);
        }
    }
   
    
    public void fillList()
    {
        Vector<String> quests = new Vector<String>();
        BufferedReader in = new BufferedReader(new InputStreamReader(
                        getClass().getResourceAsStream("Quests/All.txt")));
        numOfQuests = 0;
        try {
           // read line after line:
            while (true)
            {   
                String s=in.readLine();
                if (s == null) break;
                quests.add(s + "\n");
                numOfQuests++;
            }
            in.close();
        }
        catch (Exception ex) { System.out.println("FUCK!");  }
        QuestList.setListData(quests);
        
    }
    
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc=" Generated Code ">//GEN-BEGIN:initComponents
    private void initComponents() {
        BorderPanel = new javax.swing.JPanel();
        TitleBarPanel = new javax.swing.JPanel();
        jLabel1 = new javax.swing.JLabel();
        jScrollPane1 = new javax.swing.JScrollPane();
        QuestList = new javax.swing.JList();
        LoadButton = new javax.swing.JButton();
        CancelButton = new javax.swing.JButton();

        getContentPane().setLayout(null);

        setUndecorated(true);
        BorderPanel.setLayout(null);

        BorderPanel.setBorder(javax.swing.BorderFactory.createTitledBorder(""));
        TitleBarPanel.setLayout(null);

        TitleBarPanel.setBackground(new java.awt.Color(255, 204, 102));
        TitleBarPanel.setBorder(javax.swing.BorderFactory.createTitledBorder(""));
        jLabel1.setText("Load Quest");
        TitleBarPanel.add(jLabel1);
        jLabel1.setBounds(10, 2, 70, 14);

        BorderPanel.add(TitleBarPanel);
        TitleBarPanel.setBounds(0, 0, 190, 20);

        jScrollPane1.setViewportView(QuestList);

        BorderPanel.add(jScrollPane1);
        jScrollPane1.setBounds(10, 20, 170, 160);

        LoadButton.setText("Load");
        BorderPanel.add(LoadButton);
        LoadButton.setBounds(10, 190, 80, 23);

        CancelButton.setText("Cancel");
        BorderPanel.add(CancelButton);
        CancelButton.setBounds(100, 190, 80, 23);

        getContentPane().add(BorderPanel);
        BorderPanel.setBounds(0, 0, 190, 230);

        pack();
    }// </editor-fold>//GEN-END:initComponents
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JPanel BorderPanel;
    private javax.swing.JButton CancelButton;
    private javax.swing.JButton LoadButton;
    private javax.swing.JList QuestList;
    private javax.swing.JPanel TitleBarPanel;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JScrollPane jScrollPane1;
    // End of variables declaration//GEN-END:variables
    
}
